function Q_I()
% function [vbprb, allFI]=Q_I(vbprb, g_vals)
% maximises the negatiove free energy of the model
% w.r.t. the approximate posterior over all nsubsets
% model indicators. (i. e. over all Ig).
%
% In: 
% vbprb:    a vbprb object as is generated by vbprobit
% g_vals:   additional parameters and values used for updating the model.
%
% Out:
% vbprb:    the vbprb object with all Q(Ig) updated.
% allFI:    for every subset, the residual approximate log 
%           evidence after maximisation.
%           This information is generated here inevitably and 
%           further used in the calculation of the overall free 
%           energy. If it is used, it is vital that this update is the
%           last one before the free energy is updated. (otherwise the
%           values are wrong).
%
% (C) P. Sykacek 2005
% mod 2006: global vbprb, g_vals and allFI; 

global vbprb;
global g_vals;
global allFI;

% allFI [nsubsets x 2]
get_FI;
l_allFI=allFI';
nsubsets=size(l_allFI, 2);
% vbprb.allIgprobs [2 x nsubsets]; 
% numerically stable calculation.
allones=ones(1, nsubsets);
% size(vbprb.allIgprobs)
% size(allones)
% size(allFI)
vbprb.allIgprobs(1,:)=allones./(allones+exp(l_allFI(2,:)-l_allFI(1,:)));
vbprb.allIgprobs(2,:)=allones-vbprb.allIgprobs(1,:);