function Q_lambda()
% function [vbprb]=Q_lambda(vbprb, g_vals)
% updates the distribution over the precisions of the
% zero mean Gaussian prior over the regression parameters.
% 
% (C) P. Sykacek 2005
% modification: we have now a loop over systems.
% mod 2006: global vbprb and g_vals 

global vbprb;
global g_vals;
nsys=length(vbprb.sys);
for sctr=1:nsys
    g_p=ones(size(vbprb.sys(sctr).g_p))*vbprb.g;
    h_p=ones(size(vbprb.sys(sctr).h_p))*vbprb.h;
    nsubsets=length(vbprb.sys(sctr).g_mdls);
    n_I=length(vbprb.sys(sctr).g_mdls(1).i_mdl);
    n=1;
    while n <= nsubsets % over all subsets
        m=1;
        while m <= n_I  % and indicator variables
            % calculate the Ig contribution to the neg. free energy
            % get some values into local store (shorter equns)
            indim=vbprb.sys(sctr).g_mdls(n).i_mdl(m).n_in;
            P_I=vbprb.allIgprobs(m,n);
            g_p(1:indim)=g_p(1:indim)+0.5*P_I*ones(indim, 1);
            beta=vbprb.sys(sctr).g_mdls(n).i_mdl(m).beta;
            C=vbprb.sys(sctr).g_mdls(n).i_mdl(m).C;
            h_p(1:indim)=h_p(1:indim)+0.5*P_I*(beta.^2+diag(C));
            m=m+1;
        end
        n=n+1;
    end
    vbprb.sys(sctr).g_p=g_p;
    vbprb.sys(sctr).h_p=h_p;
end