function Q_z()
% function [vbprb]=Q_z(vbprb, g_vals)
% updates for all subsets and indicator levels the distribution over
% the latent variables of the probit glm.
% The distribution is entirely determined by the 
% mean of the latent variables. precision and
% truncation do not change.
% 
% (C) P. Sykacek 2005
% modification: we have now a loop over systems.
% mod 2006 - global vbprb and g_vals
global vbprb;
global g_vals;

nsys=length(vbprb.sys);
for sctr=1:nsys
    nsubsets=length(vbprb.sys(sctr).g_mdls);
    % nr indicators
    n_I=length(vbprb.sys(sctr).g_mdls(1).i_mdl);
    n=1;
    while n <= nsubsets % over all subsets
        m=1;
        while m <= n_I  % and indicator variables
            % calculate the Ig contribution to the neg. free energy
            % get some values into local store (shorter equns)
            indim=vbprb.sys(sctr).g_mdls(n).i_mdl(m).n_in;
            in=g_vals(sctr).g_in{n,m}; 
            vbprb.sys(sctr).latmeans(:,n,m)=in*vbprb.sys(sctr).g_mdls(n).i_mdl(m).beta;
            m=m+1;
        end
        n=n+1;
    end
end