function [allsysdata]=allrandomize(allsysdata)
% function [allsysdata]=allrandomize(allsysydata)
% randomizes rows in each dataset of allsysdata.
% IN
% allsysdata:   cell array {1 x nsys}, each entry describing the 
%               training data of the n-th system.
% OUT
% allsysdata:   the same data however with each systems training data in
%               randomly reshuffled row order.
%
% (C) P. Sykacek 2005.

nsys=length(allsysdata);
for n=1:nsys
    thisdata=allsysdata{n};
    thisdata=randomizedata(thisdata, 1);
    allsysdata{n}=thisdata;
end