function vbprb_tran(dodebug)
% function [vbprb]=vbprb_tran(vbprb, g_vals, dodebug)
% wrapper around variational bayesian solution for the
% hierarchical probit GLM.
%
% NEW 2006 - modify for global vbprb and g_vals (speed).
% IN: 
% vbprb :   object for variational Bayesian hierarchical probit GLM 
%           as generated from vballgprb.
% g_vals:   additional information like targets and inputs that are used 
%           during inference.
%
% OUT:
% vbprb:    infered vbprb object.
%
% (C) P. Sykacek 2005
%
% new version: have also a hierarchical prior over the indicator using dirichlet 
% (beta) distributions over the indicator priors.
% For combining systems we do no modifications here. The new objects are passed on 
% to the update functions, which in turn need modifications.

global vbprb;
global g_vals;
global allFI;

if nargin < 1
    dodebug=0;
end
oldlgevid=F_Q;
n=1;
cont_upd=1;
while cont_upd
    if mod(n, 10)==0; disp(n); end
    %n
    %[vbprb]=Q_beta(vbprb, g_vals);   % update multivariate Normals over all regression coefficients
    Q_beta;
    %if dodebug
    %    [allFzold]=F_Qz(vbprb, g_vals);
    %end
    %[vbprb]=Q_z(vbprb, g_vals);      % update truncated normal processes over latent (link) variables 
    Q_z;
    %if dodebug
    %    [allFznew]=F_Qz(vbprb, g_vals);
    %    diffFz=allFznew - allFzold;
    %    wrgmove=allFznew < allFzold;
    %    if any(wrgmove)
    %        [ns, nsub, nmdl]=size(wrgmove);
    %        for n=1:nsub
    %            for m=1:nmdl
    %                nwrg=sum(wrgmove(:, n, m));
    %                if nwrg>0
    %                    sumdiff=sum(diffFz(find(wrgmove(:,n,m)),n,m));
    %                    disp(sprintf('subset %d model %d, %d moves down by %f', n, m, nwrg, sumdiff));
    %                end
    %            end
    %        end
    %    end
    %end
    %[vbprb]=Q_H(vbprb, g_vals);
    %[vbprb]=Q_lambda(vbprb, g_vals); % update diagonal Wishart of common prior precisions
    Q_lambda;
    %[vbprb]=Q_theta(vbprb, g_vals); % uodate beta distribution over all indicator priors.
    Q_theta;
    %vbprb.g_p./vbprb.h_p
    %[vbprb, allFI]=Q_I(vbprb, g_vals); % update abinomial distributions over moidel indicators
    Q_I;
    %allFI
    %vbprb.allIgprobs
    [applgevid, p1, p2, p3]=F_Q; % get negative free energy.
    if dodebug
       if applgevid<oldlgevid
           disp(sprintf('olg logevid: %f larger new logevid: %f', oldlgevid,applgevid));
       end
    end
    %applgevid
    vbprb.lgevids(n)=applgevid;
    vbprb.p1(n)=p1;
    vbprb.p2(n)=p2;
    cont_upd=(abs(applgevid-oldlgevid)>vbprb.acceps) &...
        n <= vbprb.maxit;
    oldlgevid=applgevid;
    %cont_upd= n <= 20; %vbprb.maxit;
    n=n+1;
end
% store the log marginal likelihoods
vbprb.allFI=allFI';